//Copyright (C) 2005
//CLC-4-TTS Firefox Extension: SAPI5 DLL
//by Charles L. Chen

 
//This program is free software; you can redistribute it
//and/or modify it under the terms of the GNU General Public
//License as published by the Free Software Foundation;
//either version 2.1 of the License, or (at your option) any
//later version.  This program is distributed in the hope
//that it will be useful, but WITHOUT ANY WARRANTY; without
//even the implied warranty of MERCHANTABILITY or FITNESS FOR
//A PARTICULAR PURPOSE. See the GNU General Public License for
//more details.  You should have received a copy of the GNU
//General Public License along with this program; if not, look
//on the web at on the web at http://www.gnu.org/copyleft/gpl.html
//or write to the Free Software Foundation, Inc., 59 Temple Place,
//Suite 330, Boston, MA 02111-1307, USA.

//Last modified 2-18-2005

#include <atlbase.h>
#include <sapi.h>
#include "CLC_SAPI.h"

ISpVoice * clcVoice = NULL;


/* Implementation file */
NS_IMPL_ISUPPORTS1(CLC_SAPI, ICLC_SAPI)

CLC_SAPI::CLC_SAPI()
{
  /* member initializers and constructor code */
}

CLC_SAPI::~CLC_SAPI()
{
  /* destructor code */
}

/* void Init (); */
NS_IMETHODIMP CLC_SAPI::Init()
{
    if (FAILED(CoInitialize(NULL)))
	{
        return NS_OK;
	}
    CoCreateInstance(CLSID_SpVoice, NULL, CLSCTX_ALL, IID_ISpVoice, (void **)&clcVoice);
	return NS_OK;
}

/* void Shutdown (); */
NS_IMETHODIMP CLC_SAPI::Shutdown()
{
	clcVoice->Release();
	clcVoice = NULL;
	CoUninitialize();
	return NS_OK;
}

/* void Speak (in string x, in long y); */
//x should be the text string to be spoken
//y is the parameter - 0 for synchronous, 
//                     1 for asynchronous, 
//                     2 for purge before speaking
//
//Many thanks to Kenji Inoue for fixing this function
//
NS_IMETHODIMP CLC_SAPI::Speak(const PRUnichar *x, PRInt32 y)
{
        clcVoice->Speak(x, y, NULL);
	return NS_OK;
}

/* void Stop (); */
NS_IMETHODIMP CLC_SAPI::Stop()
{
	CComBSTR b_temp_string(" ");
	clcVoice->Speak(b_temp_string, 2, NULL);
	SysFreeString(b_temp_string);
	return NS_OK;
}

/* boolean ReadyToSpeak (); */
//True if ready to speak, else false.
//The SDK documentation enumerations for SPRUNSTATE  is incorrect.
//Should be 0 = Waiting, 1 = Done, and 2 = Speaking.
//The official documentation starts the enumeration at 1 (Done)
//and does not list the 0 (Waiting) value.
NS_IMETHODIMP CLC_SAPI::ReadyToSpeak(PRBool *_retval)
{
	SPVOICESTATUS voiceStatus;
	clcVoice->GetStatus(&voiceStatus, NULL);
	if (voiceStatus.dwRunningState == 1){
		*_retval = true;
		return NS_OK;
	}
	*_retval = false;
	return NS_OK;
}



